<?php

class rdc_sdb_eclairage extends hook
{
	public $hookName = "rdc_sdb_eclairage";
	public $active = true;

	/*			already defined in hook class			*/
	// public $active = true;
	//public $initlialized = false;

	public $delay = 3;				// amount of time in $timeunit
	public $delayManual = 20;		// amount of time in $timeunit for manual mode
	public $timeUnit = "minute";	// unit of time for delay, second, minute, day, week, month, year
	// list of devices we are listening to

	// devicelist[$ieeAddress][0] => property to watch
	// devicelist[$ieeAddress][1] => initialized = true
	protected $devicelist = array(
		RDC_SDB_DOUCHE_MVMT => "occupancy",
		RDC_SDB_PLAFOND_MVMT => "occupancy",
		RDC_SDB_MVMT => "occupancy",
		RDC_SDB_WC_ECLAIRAGE => "state_l1"
	);
	protected $actionneurs = array(
		array(RDC_SDB_DOUCHE_MVMT, "occupancy", 1),
		array(RDC_SDB_PLAFOND_MVMT, "occupancy", 1),
		array(RDC_SDB_MVMT, "occupancy", 1)
	);

	function installHooks(&$indexDevices)
	{
		return $this->installHooksFunction($indexDevices);
	}

	// callback fonction. Is called with these 3 parameters
	public function callBack(&$device, $property, $value)
	{
		global $indexDevices;
		//var_dump($value);
		if ($this->active)
		{
			if (array_key_exists(RDC_SDB_WC_ECLAIRAGE, $indexDevices))
			{
				$deviceTarget = &$indexDevices[RDC_SDB_WC_ECLAIRAGE];
				logger(DEBUG, "Callback : " . $this->hookName, __FILE__ . ":" . __LINE__);
				$method = $deviceTarget->properties["state_l1"]["method"];
				switch($property)
				{
					case "occupancy":
						logger(DEBUG, _("CASE: occupancy"), __FILE__ . ":" . __LINE__);
						if ($value == ON)
						{
							if($method == IDLE)
							{
								logger(DEBUG, _("lighting with method auto"), __FILE__ . ":" . __LINE__);
								//$deviceTarget->properties["state_l1"]["method"] = AUTO;
								$this->send("ON", AUTO);
								removeEvent($deviceTarget, "state", "OFF");
							}
						}elseif (!testActionneurs($this->actionneurs))
						{
							logger(DEBUG, _("Actionneurs are all false"), __FILE__ . ":" . __LINE__);
							$this->send("OFF", IDLE);
							removeEvent($deviceTarget, "state", "OFF");
						}
						break;
					case "state_l1":
						logger(DEBUG, _("CASE: state_l1"), __FILE__ . ":" . __LINE__);
						if ($value == "ON")
						{
							if ($method == IDLE)
							{
								logger(DEBUG, _("State_l1 is IDLE"), __FILE__ . ":" . __LINE__);
								removeEvent($deviceTarget, "state_l1", "OFF");
								$deviceTarget->properties["state_l1"]["method"] = MANUAL;
								//setDelay($deviceTarget, $this->delayManual, $this->timeUnit, "state_l1", "OFF", true, IDLE);
							}
						}elseif ($value == "OFF" and $method == MANUAL)
						{
							$deviceTarget->properties["state_l1"]["method"] = IDLE;
							removeEvent($deviceTarget, "state_l1", "OFF");
							//$deviceTarget->properties["state_l1"]["method"] = IDLE;
							logger(DEBUG, _("State_l1 is false light is off and method is ") . $method, __FILE__ . ":" . __LINE__);
						}
						break;
				}
				logger (INFO, sprintf(_("%s: notification received from MQTT from %s => parameter: %s value: %s method: %s"), $this->hookName, $device->friendlyName, $property, bool2string($value), $deviceTarget->properties["state_l1"]["method"]), __FILE__ . ":" . __LINE__);
			}else
			{
				logger (ERROR, RDC_SDB_WC_ECLAIRAGE . _(" does not exists"), __FILE__ . ":" . __LINE__);
			}
		}
	}

	private function send($state, $method)
	{
		global $indexDevices;

		$device = &$indexDevices[RDC_SDB_WC_ECLAIRAGE];
		$device->properties["state_l1"]["method"] = $method;
		$msg = array("state_l1" => $state);
		$device->payload = $msg;
		$device->set("state_l1");
		logger(INFO, sprintf(_("publishing message: %s to %s"), $state, $device->friendlyName), __FILE__ . ":" . __LINE__);

	}
}
$hooks["rdc_sdb_eclairage"] = new rdc_sdb_eclairage();

?>
